=== modified file 'plugins.d/mandos-client.c'
--- plugins.d/mandos-client.c	2011-11-11 09:10:58 +0000
+++ plugins.d/mandos-client.c	2011-10-05 16:00:56 +0000
@@ -123,7 +123,6 @@
 #define PATHDIR "/conf/conf.d/mandos"
 #define SECKEY "seckey.txt"
 #define PUBKEY "pubkey.txt"
-#define HOOKDIR "/lib/mandos/network-hooks.d"
 
 bool debug = false;
 static const char mandos_protocol_version[] = "1";
@@ -1086,94 +1085,12 @@
   errno = old_errno;
 }
 
-bool get_flags(const char *ifname, struct ifreq *ifr){
-  int ret;
-  
-  int s = socket(PF_INET6, SOCK_DGRAM, IPPROTO_IP);
-  if(s < 0){
-    perror_plus("socket");
-    return false;
-  }
-  strcpy(ifr->ifr_name, ifname);
-  ret = ioctl(s, SIOCGIFFLAGS, ifr);
-  if(ret == -1){
-    if(debug){
-      perror_plus("ioctl SIOCGIFFLAGS");
-    }
-    return false;
-  }
-  return true;
-}
-
-bool good_flags(const char *ifname, const struct ifreq *ifr){
-  
-  /* Reject the loopback device */
-  if(ifr->ifr_flags & IFF_LOOPBACK){
-    if(debug){
-      fprintf(stderr, "Rejecting loopback interface \"%s\"\n",
-	      ifname);
-    }
-    return false;
-  }
-  /* Accept point-to-point devices only if connect_to is specified */
-  if(connect_to != NULL and (ifr->ifr_flags & IFF_POINTOPOINT)){
-    if(debug){
-      fprintf(stderr, "Accepting point-to-point interface \"%s\"\n",
-	      ifname);
-    }
-    return true;
-  }
-  /* Otherwise, reject non-broadcast-capable devices */
-  if(not (ifr->ifr_flags & IFF_BROADCAST)){
-    if(debug){
-      fprintf(stderr, "Rejecting non-broadcast interface \"%s\"\n",
-	      ifname);
-    }
-    return false;
-  }
-  /* Reject non-ARP interfaces (including dummy interfaces) */
-  if(ifr->ifr_flags & IFF_NOARP){
-    if(debug){
-      fprintf(stderr, "Rejecting non-ARP interface \"%s\"\n", ifname);
-    }
-    return false;
-  }
-  
-  /* Accept this device */
-  if(debug){
-    fprintf(stderr, "Interface \"%s\" is good\n", ifname);
-  }
-  return true;
-}
-
 /* 
  * This function determines if a directory entry in /sys/class/net
  * corresponds to an acceptable network device.
  * (This function is passed to scandir(3) as a filter function.)
  */
 int good_interface(const struct dirent *if_entry){
-  int ret;
-  if(if_entry->d_name[0] == '.'){
-    return 0;
-  }
-  struct ifreq ifr;
-
-  if(not get_flags(if_entry->d_name, &ifr)){
-    return 0;
-  }
-  
-  if(not good_flags(if_entry->d_name, &ifr)){
-    return 0;
-  }
-  return 1;
-}
-
-/* 
- * This function determines if a directory entry in /sys/class/net
- * corresponds to an acceptable network device which is up.
- * (This function is passed to scandir(3) as a filter function.)
- */
-int up_interface(const struct dirent *if_entry){
   ssize_t ssret;
   char *flagname = NULL;
   if(if_entry->d_name[0] == '.'){
@@ -1241,12 +1158,6 @@
     }
     return 0;
   }
-
-  /* Reject down interfaces */
-  if(not (flags & IFF_UP)){
-    return 0;
-  }
-  
   /* Accept point-to-point devices only if connect_to is specified */
   if(connect_to != NULL and (flags & IFF_POINTOPOINT)){
     if(debug){
@@ -1290,50 +1201,6 @@
   return 1;
 }
 
-/* Is this directory entry a runnable program? */
-int runnable_hook(const struct dirent *direntry){
-  int ret;
-  struct stat st;
-  
-  if((direntry->d_name)[0] == '\0'){
-    /* Empty name? */
-    return 0;
-  }
-  
-  /* Save pointer to last character */
-  char *end = strchr(direntry->d_name, '\0')-1;
-  
-  if(*end == '~'){
-    /* Backup name~ */
-    return 0;
-  }
-  
-  if(((direntry->d_name)[0] == '#')
-     and (*end == '#')){
-    /* Temporary #name# */
-    return 0;
-  }
-  
-  /* XXX more rules here */
-  
-  ret = stat(direntry->d_name, &st);
-  if(ret == -1){
-    if(debug){
-      perror_plus("Could not stat plugin");
-    }
-    return 0;
-  }
-  if(not (st.st_mode & S_ISREG)){
-    /* Not a regular file */
-    return 0;
-  }
-  if(not (st.st_mode & (S_IXUSR | S_IXGRP | S_IXOTH))){
-    /* Not executable */
-    return 0;
-  }
-  return 1;
-}
-
 int avahi_loop_with_timeout(AvahiSimplePoll *s, int retry_interval){
   int ret;
   struct timespec now;
@@ -1651,47 +1518,10 @@
     }
   }
   
-  /* Find network hooks and run them */
-  {
-    struct dirent **direntries;
-    struct dirent *direntry;
-    int numhooks = scandir(HOOKDIR, &direntries, runnable_hook,
-			   alphasort);
-    int devnull = open("/dev/null", O_RDONLY);
-    for(int i = 0; i < numhooks; i++){
-      direntry = direntries[0];
-      char *fullname = NULL;
-      ret = asprintf(&fullname, "%s/%s", tempdir,
-		     direntry->d_name);
-      if(ret < 0){
-	perror_plus("asprintf");
-	continue;
-      }
-      pid_t hook_pid = fork();
-      if(hook_pid == 0){
-	/* Child */
-	dup2(devnull, STDIN_FILENO);
-	close(devnull);
-	dup2(STDERR_FILENO, STDOUT_FILENO);
-	setenv("DEVICE", interface, 1);
-	setenv("VERBOSE", debug ? "1" : "0", 1);
-	setenv("MODE", "start", 1);
-	/* setenv( XXX more here */
-	ret = execl(fullname, direntry->d_name, "start");
-	perror_plus("execl");
-      }
-      free(fullname);
-      if(quit_now){
-	goto end;
-      }
-    }
-    close(devnull);
-  }
-  
   if(not debug){
     avahi_set_log_function(empty_log);
   }
-  
+
   if(interface[0] == '\0'){
     struct dirent **direntries;
     ret = scandir(sys_class_net, &direntries, good_interface,
@@ -2039,7 +1869,7 @@
     if (not quit_now){
       exitcode = EXIT_SUCCESS;
     }
-    
+
     goto end;
   }
   
@@ -2142,8 +1972,6 @@
     }
   }
   
-  /* XXX run network hooks "stop" here  */
-  
   /* Take down the network interface */
   if(take_down_interface){
     /* Re-raise priviliges */

